﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using Microsoft.AspNet.SignalR;
using Newtonsoft.Json;

namespace MindMap
{
    public class DiagramHub : Hub
    {
        public void NodeCreated(NodeModel clientModel)
        {
            Clients.AllExcept(Context.ConnectionId).nodeCreated(clientModel);
        }
        public void NodeModified(NodeModel clientModel)
        {
            Clients.AllExcept(Context.ConnectionId).nodeModified(clientModel);
        }
        public void NodeTextEdited(NodeModel clientModel)
        {
            Clients.AllExcept(Context.ConnectionId).nodeTextEdited(clientModel);
        }
        public void NodeDeleted(NodeModel clientModel)
        {
            Clients.AllExcept(Context.ConnectionId).nodeDeleted(clientModel);
        }
        public void LinkCreated(LinkModel clientModel)
        {
            Clients.AllExcept(Context.ConnectionId).linkCreated(clientModel);
        }
        public void LinkModified(LinkModel clientModel)
        {
            Clients.AllExcept(Context.ConnectionId).linkModified(clientModel);
        }
        public void LinkTextEdited(LinkModel clientModel)
        {
            Clients.AllExcept(Context.ConnectionId).linkTextEdited(clientModel);
        }
        public void LinkDeleted(LinkModel clientModel)
        {
            Clients.AllExcept(Context.ConnectionId).linkDeleted(clientModel);
        }
        public void Load(string url)
        {
            Clients.All.load(url);
        }

    }

    public class NodeModel
    {
        [JsonProperty("x")]
        public double X { get; set; }

        [JsonProperty("y")]
        public double Y { get; set; }

        [JsonProperty("width")]
        public double Width { get; set; }

        [JsonProperty("height")]
        public double Height { get; set; }

        [JsonProperty("id")]
        public string Id { get; set; }

        [JsonProperty("text")]
        public string Text { get; set; }
    }

    public class LinkModel
    {
        [JsonProperty("id")]
        public string Id { get; set; }

        [JsonProperty("originId")]
        public string OriginId { get; set; }

        [JsonProperty("destinationId")]
        public string DestinationId { get; set; }

        [JsonProperty("text")]
        public string Text { get; set; }
    }
}